// Sample.cpp : WavePlay TvAvP[V
//

#include "stdafx.h"
#include "Sample.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ̃TvvÓAC++̃\[XR[hłB
// C++ȓǎ҂̂߂ɊăNXg킸ɏĂ܂B
// ̃vO͍Đ菇̐ړIƂďĂ܂̂ŁA
// HIȃvOɓڂꍇ́AړIɍ킹ďĉB

// bɈڐAꍇAϐ̐錾Ȃǈꕔ蒼Kv܂B
// ܂AC++ɈڐAꍇ́A
//   obt@ɊւNX
//   EF[ut@CɊւNX
//   EF[uĐɊւNX
// `Aꂼ֘A֐퐔NXɒǉƗǂł傤B

/////////////////////////////////////////////////////////////////////////////
// Wave Buffer

#define NumWaveBuff		4
#define WaveBuffSize	65536

HANDLE		m_hHeap;
LPWAVEHDR	m_pWaveHdr[NumWaveBuff];
LPSTR		m_pWaveBuff[NumWaveBuff];

/////////////////////////////////////////////////////////////////////////////
// Init Wave Buff

BOOL InitWaveBuff(void)
{
	for (long i=0; i<NumWaveBuff; ++i)
	{
		m_pWaveHdr[i]  = NULL;
		m_pWaveBuff[i] = NULL;
	}
	m_hHeap = HeapCreate(0,0,0);

	if (! m_hHeap)
	{
		AfxMessageBox(IDS_HEAPCREATE);
		return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Exit Wave Buff

BOOL ExitWaveBuff(void)
{
	return HeapDestroy(m_hHeap);
}

/////////////////////////////////////////////////////////////////////////////
// Alloc Wave Buff

BOOL AllocWaveBuff(void)
{
	for (long i=0; i<NumWaveBuff; ++i)
	{
		m_pWaveHdr[i] = (LPWAVEHDR)HeapAlloc(
			m_hHeap, HEAP_ZERO_MEMORY, sizeof(WAVEHDR));

		m_pWaveBuff[i] = (LPSTR)HeapAlloc(
			m_hHeap, HEAP_ZERO_MEMORY, WaveBuffSize);

		if ((! m_pWaveHdr[i])||(! m_pWaveBuff[i])) {
			AfxMessageBox(IDS_ALLOCMEMORY);
			return FALSE;
		}
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Free Wave Buff

void FreeWaveBuff(void)
{
	for (long i=0; i<NumWaveBuff; ++i)
	{
		if (m_pWaveHdr[i])
		{
			HeapFree(m_hHeap, 0, m_pWaveHdr[i]);
			m_pWaveHdr[i] = NULL;
		}
		if (m_pWaveBuff[i])
		{
			HeapFree(m_hHeap, 0, m_pWaveBuff[i]);
			m_pWaveBuff[i] = NULL;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// Wave File

HMMIO			m_hMio;
DWORD			m_nDataSize;
WAVEFORMATEX	m_wfxWaveForm;

/////////////////////////////////////////////////////////////////////////////
// Init Param

void InitWaveFile(void)
{
	m_hMio = NULL;
	m_nDataSize = 0;
	ZeroMemory(&m_wfxWaveForm, sizeof(WAVEFORMATEX));
}

/////////////////////////////////////////////////////////////////////////////
// Open Wave File

MMRESULT OpenWaveFile(LPCTSTR strFilePath)
{
MMIOINFO	ioInfo;
MMCKINFO	ciRiffChunk;
MMCKINFO	ciSubChunk;

	if (m_hMio)
	{
		AfxMessageBox(IDS_ALREADYOPENWAVEFILE);
		return MMIOERR_CANNOTOPEN;
	}

	m_nDataSize = 0;
	MMRESULT ret = MMSYSERR_NOERROR;

	// FilePath Check
	if (! strlen(strFilePath))
	{
		AfxMessageBox(IDS_NOFILENAME);
		return MMIOERR_FILENOTFOUND;
	}

	// Open File
	ZeroMemory(&ioInfo, sizeof(MMIOINFO));
	m_hMio = mmioOpen((LPSTR)strFilePath, &ioInfo, MMIO_READ);

	if (! m_hMio)
	{
		AfxMessageBox(IDS_WAVEFILEOPEN);
		return ioInfo.wErrorRet;
	}

	// Find Riff Chunk
	ciRiffChunk.fccType = mmioFOURCC('W','A','V','E');
	ret = mmioDescend(m_hMio, &ciRiffChunk, NULL, MMIO_FINDRIFF);

	if (ret)
	{
		AfxMessageBox(IDS_WAVERIFFCHUNK);
		return ret;
	}

	// Find Format Chunk
	ciSubChunk.ckid =mmioFOURCC ('f','m','t',' ');
	ret = mmioDescend(m_hMio, &ciSubChunk, &ciRiffChunk, MMIO_FINDCHUNK);

	if (ret)
	{
		AfxMessageBox(IDS_WAVEFMTCHUNK);
		return ret;
	}

	// Read Format Chunk
	ZeroMemory(&m_wfxWaveForm, sizeof(WAVEFORMATEX));
	long nFmtSize = min(ciSubChunk.cksize, sizeof(WAVEFORMATEX));
	long nReadSize = mmioRead(m_hMio, (HPSTR)&m_wfxWaveForm, nFmtSize);

	if (nReadSize != nFmtSize)
	{
		AfxMessageBox(IDS_WAVEFILEREAD);
		return MMIOERR_CANNOTREAD;
	}

	// Find Data Chunk
	mmioAscend(m_hMio, &ciSubChunk, 0);
	ciSubChunk.ckid = mmioFOURCC('d','a','t','a');
	ret = mmioDescend(m_hMio, &ciSubChunk, &ciRiffChunk, MMIO_FINDCHUNK);

	if (ret)
	{
		AfxMessageBox(IDS_WAVEDATACHUNK);
		return ret;
	}

	// Set Wave Info
	m_nDataSize = ciSubChunk.cksize;

	return ret;
}

/////////////////////////////////////////////////////////////////////////////
// Close Wave File

MMRESULT CloseWaveFile(void)
{
	MMRESULT ret = MMSYSERR_NOERROR;

	if (m_hMio)
	{
		ret = mmioClose(m_hMio, 0);
		m_hMio = NULL;
		if (ret)
		{
			AfxMessageBox(IDS_WAVEFILECLOSE);
		}
	}
	return ret;
}

/////////////////////////////////////////////////////////////////////////////
// Wave Play

HWAVEOUT	m_hWaveOut;
long		m_lPrepPage;
DWORD		m_nCurPos;

/////////////////////////////////////////////////////////////////////////////
// Init Param

void InitWaveOut(void)
{
	m_hWaveOut  = NULL;
	m_lPrepPage = 0;
	m_nCurPos   = 0;
}

/////////////////////////////////////////////////////////////////////////////
// Query WaveOut Device

BOOL QueryWaveOutDevice(UINT uDevID)
{
	MMRESULT ret = waveOutOpen(
		NULL,
		uDevID,
		&m_wfxWaveForm,
		0,
		0,
		WAVE_FORMAT_QUERY);

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_QUERYOUTDEVICE);
		return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Open WaveOut Device

BOOL OpenWaveOutDevice(
	UINT	uDevID,
	HWND	hWnd)
{
	if (m_hWaveOut)
	{
		AfxMessageBox(IDS_ALREADYOPENOUTDEVICE);
		return FALSE;
	}

	MMRESULT ret = waveOutOpen(
		&m_hWaveOut,
		uDevID,
		&m_wfxWaveForm,
		(DWORD)hWnd,
		0,
		CALLBACK_WINDOW);

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_OPENOUTDEVICE);
		return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Close WaveOut Device

BOOL CloseWaveOutDevice(void)
{
	if (! m_hWaveOut)		return TRUE;

	MMRESULT ret = waveOutClose(m_hWaveOut);
	m_hWaveOut = NULL;

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_CLOSEOUTDEVICE);
		return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Init Play Wave

BOOL InitPlayWave(void)
{
	if (! m_hWaveOut)		return TRUE;

	MMRESULT ret = MMSYSERR_NOERROR;

	m_lPrepPage = 0;
	m_nCurPos   = 0;

	for (long i=0; i<NumWaveBuff; ++i)
	{
		LPWAVEHDR pWaveHdr = m_pWaveHdr[i];
		pWaveHdr->lpData   = m_pWaveBuff[i];
		pWaveHdr->dwUser   = 0;
		pWaveHdr->dwFlags  = 0;
		pWaveHdr->dwLoops  = 0;

		if (! SetWaveOutData(pWaveHdr))		break;

		ret = waveOutPrepareHeader(m_hWaveOut, pWaveHdr, sizeof(WAVEHDR));

		if (ret != MMSYSERR_NOERROR)
		{
			AfxMessageBox(IDS_WAVEOUTPREPHEADER);
			break;
		}
		ret = waveOutWrite(m_hWaveOut, pWaveHdr, sizeof(WAVEHDR));

		if (ret != MMSYSERR_NOERROR)
		{
			AfxMessageBox(IDS_WAVEOUTWRITE);
			break;
		}
		++m_lPrepPage;
	}
	return (ret == MMSYSERR_NOERROR) ? TRUE : FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Cont Play Wave

BOOL ContPlayWave(
	HWAVEOUT	hWavePlay,
	LPWAVEHDR	pWaveHdr)
{
	MMRESULT ret = MMSYSERR_NOERROR;

	if (m_lPrepPage == 0)
	{
		return FALSE;			// łɏꂽobt@݂͑Ȃ
	}
	if (!(pWaveHdr->dwFlags & WHDR_DONE))
	{
		return FALSE;			// ܂tł
	}
	if (!(pWaveHdr->dwFlags & WHDR_PREPARED))
	{
		return FALSE;			// ꂽobt@ł͂Ȃ
	}
	ret = waveOutUnprepareHeader(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_WAVEOUTUNPREPHEADER);
	}
	if (ret == MMSYSERR_NOERROR)
	{
		--m_lPrepPage;
	}
	if (! SetWaveOutData(pWaveHdr))		return FALSE;

	pWaveHdr->dwFlags = 0;

	ret = waveOutPrepareHeader(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_WAVEOUTPREPHEADER);
	}
	ret = waveOutWrite(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_WAVEOUTWRITE);
	}
	++m_lPrepPage;

	return (ret == MMSYSERR_NOERROR) ? TRUE : FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Stop Play Wave

void StopPlayWave(void)
{
	if (! m_hWaveOut)		return;

	MMRESULT ret = waveOutReset(m_hWaveOut);

	if (ret != MMSYSERR_NOERROR)
	{
		AfxMessageBox(IDS_WAVEOUTRESET);
	}

	for (long i=0; i<NumWaveBuff; ++i)
	{
		if (!  m_pWaveHdr[i])							continue;
		if (! (m_pWaveHdr[i]->dwFlags & WHDR_PREPARED))	continue;
		if (! (m_pWaveHdr[i]->dwFlags & WHDR_DONE))		continue;

		ret = waveOutUnprepareHeader(m_hWaveOut, m_pWaveHdr[i], sizeof(WAVEHDR));

		if (ret != MMSYSERR_NOERROR)
		{
			AfxMessageBox(IDS_WAVEOUTUNPREPHEADER);
		}
	}
	m_lPrepPage = 0;
}

/////////////////////////////////////////////////////////////////////////////
// Set WaveOut Data

BOOL SetWaveOutData(LPWAVEHDR pWaveHdr)
{
	long nMove = min(WaveBuffSize, m_nDataSize - m_nCurPos);
	if (nMove <= 0)		return FALSE;

	long nRead = mmioRead(m_hMio, (HPSTR)pWaveHdr->lpData, nMove);
	m_nCurPos += nRead;

	if (nRead != nMove)
	{
		AfxMessageBox(IDS_WAVEFILEREAD);
		return FALSE;
	}
	pWaveHdr->dwBufferLength = nRead;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// IsPlaying

BOOL IsPlaying(void)
{
	return m_hWaveOut ? TRUE : FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// IsPlayDone

BOOL IsPlayDone(void)
{
	return (0 < m_lPrepPage) ? FALSE : TRUE;
}


